
/*
Lithobox2 is a program created to generate 3D printable lithophanes

copyright 2018 Jennifer Weiler
http://jenweiart.com
////////////////////////////////   */
ArrayList<PVector> GaussianBlur1D(ArrayList<PVector> oldA){
  
  ArrayList<PVector> newA = new ArrayList<PVector>();
  int spread = 10;
  
  for(int i=0; i<oldA.size(); i++){
    float totalValue = 0;
    float totalDivider = 0;
    
    int min = i-spread;
    int max = i+spread;
    while(min < 0){
          min++;
          max--;
    }
    while(max >= oldA.size()){
          min++;
          max--;
    }
    
    for(int k=min; k<=max; k++){
     // if(k>=0 && k<oldA.size()){
        float relativePull = powerToDistance(abs(i-k));
        float varX = oldA.get(k).x;
        
        totalValue += (varX/relativePull);
        totalDivider += (1.0/relativePull);
     // }      
    }
       //println(totalValue +"  " + totalDivider);
       // only copy over new X, Y should stay the same
    newA.add(new PVector(  totalValue / totalDivider  , oldA.get(i).y) );     
    
  }
 // println(newA);
  return newA;
}


float powerToDistance(float p){
  
  float n = pow(p+1, .5);
  
  return n;
  
}//*/
